package com.szpg.plc.message.response.read;

import java.util.ArrayList;
import java.util.List;

import org.apache.commons.lang3.StringUtils;
import org.apache.log4j.Logger;

import com.szpg.db.dao.PgDsDao;
import com.szpg.db.dao.PgHjsbblDao;
import com.szpg.db.dao.PgDeviceDao;
import com.szpg.db.dao.impl.PgDsDaoImpl;
import com.szpg.db.dao.impl.PgHjsbblDaoImpl;
import com.szpg.db.data.PgHjsbbl;
import com.szpg.db.dao.impl.PgDeviceDaoImpl;
import com.szpg.plc.message.response.ReadMemoryCommandResponse;
import com.szpg.plc.util.ByteUtil;
import com.szpg.util.Configure;
import com.szpg.util.TimeFormat;

public class ReadDSStatusCommandResponse extends ReadMemoryCommandResponse {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = -2692039091478584257L;

	private final Logger logger = Logger.getLogger(this.getClass().getName());
	
	private List<Boolean> dsbj; // 对射报警状态
	private String[] zcList; //红外对射监测的资产列表，从配置文件中获取

	public ReadDSStatusCommandResponse() {
		dsbj = new ArrayList<Boolean>();
	}

	public List<Boolean> getDsbj() {
		return dsbj;
	}

	public void setDsbj(List<Boolean> dsbj) {
		this.dsbj = dsbj;
	}
	
	public String[] getZcList() {
		return zcList;
	}

	public void setZcList(String[] zcList) {
		this.zcList = zcList;
	}

	@Override
	public void afterAction() {
		// 1将对射报警数据存入数据库
		PgDsDao dsDao = new PgDsDaoImpl();
		PgDeviceDao deviceDao = new PgDeviceDaoImpl();
		
		// 遍历资产列表，将红外对射报警状态存入数据库
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];
			
			int id = deviceDao.findDeviceIdByCode(zcbh);
			if (id > 0) {
				dsDao.addSbjzRecord(dsbj.get(i), TimeFormat.formatTimestamp(this.getTime().getTime()), id);
			}
		}
	}

	@Override
	public void parseData(byte[] messageData) {
		// 获取目标ACU的代码
		String acucode = this.getAcucode();
		
		// 判断数据的长度是否满足要求
		if (messageData.length != Integer.parseInt(Configure.getProperty("acubl", acucode + ".DSALM.WORDCOUNT")) * 2) {
			logger.error("返回的数据长度与读取的不一致！");
			this.setValid(false);
			return;
		}
		
		// 将数据转换为字符串
		// 按照高字在前，低字在后；高字节在前，低字节在后的顺序
		String dataStr = "";
		for (int c = 0; c < messageData.length; c = c + 2) {
			dataStr = ByteUtil.binToBinString(new byte[] {messageData[c], messageData[c + 1]}) + dataStr;
		}
		
		PgHjsbblDao blDao = new PgHjsbblDaoImpl();
		
		// 获取目标ACU红外对射报警状态内存区域的起始字地址
		int start = Integer.parseInt(Configure.getProperty("acubl", acucode + ".DSALM.START"));
		
		// 获取目标ACU红外对射相关的资产列表，即红外对射设备列表
		String zcListStr = Configure.getProperty("acubl", acucode + ".DS.ZC.LIST");
		if (StringUtils.isEmpty(zcListStr) == true) {
			this.setValid(false);
			return;
		}
		zcList = zcListStr.split(";");
		
		// 解析红外对射报警状态
		for (int i = 0; i < zcList.length; i++) {
			String zcbh = zcList[i];
			
			// 解析红外对射报警状态
			PgHjsbbl almBlObj = blDao.findBlByBh(zcbh + ".Alm");
			if (null == almBlObj) {
				continue;
			}
			
			int akszdz = almBlObj.getKszdz(); //开始字地址
			int aoffset = akszdz - start; //与开始字的偏移量
			int abit = almBlObj.getSzw(); //所在位
			
			char bjBt = dataStr.charAt(dataStr.length() - 1 - aoffset * 16 - abit); // 红外对射报警状态标志位
			
			getDsbj().add(bjBt == '1' ? true : false);
		}
	}

}
